﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx.Helpers;
using System.IO;
using Styx;

using Styx.Common;

namespace GatherDismount
{
    public class DisSettings : Settings
    {
        public static readonly DisSettings AllPrefs = new DisSettings();

        public DisSettings()
            : base(Path.Combine(Utilities.AssemblyDirectory, string.Format(@"Plugins/Config/{0}-{1}-GatherDismountSettings.xml", StyxWoW.Me.RealmName, StyxWoW.Me.Name)))
        {
        }

        [Setting, DefaultValue(10)]
        public int DismountRadius { get; set; }

        [Setting, DefaultValue(0)]
        public int nodes { get; set; }

        [Setting, DefaultValue(true)]
        public bool loot { get; set; }
    }
}
