﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Bots.Gatherbuddy;
using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Color = System.Drawing.Color;
using System.Drawing;
using Levelbot.Actions.Combat;
using Styx.Pathing;
using Styx.Helpers;
using System.Threading;
using System.Diagnostics;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System.Linq.Expressions;
using System.IO;
using System.Runtime.InteropServices;
using System.Xml.Linq;
using System.Net;
using Styx.CommonBot;
using Styx.CommonBot.Frames;
using System.Windows.Media;

namespace GatherDismount
{
    public class GatherDismountPlugin : HBPlugin
    {
        #region Globals

        public override string Name { get { return "GatherDismount with combat loot"; } }
        public override string Author { get { return "Crowley"; } }
        public override Version Version { get { return new Version(0, 0, 0, 2); } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private const string DruidFlightForm = "Flight Form";
        private const string DruidSwiftFlightForm = "Swift Flight Form";
        public override string ButtonText { get { return "Settings"; } }
        public override bool WantButton { get { return true; } }


        public override void OnButtonPress()
        {
            Form1 ConfigForm = new Form1();
            ConfigForm.ShowDialog();
        }

        #endregion

        //Logging Class for your conviance
        public static void slog(string format, params object[] args)
        {
            Logging.Write(Colors.Crimson, "[Crow/BadWolf/Inrego say my loot bitches]: " + format, args);
        }
        private double LootRange
        {
            get { return LootTargeting.LootRadius; }
        }
        private IOrderedEnumerable<WoWUnit> Lootables
        {
            get
            {
                var targetsList = ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Where(
                        p => (p.Lootable || p.CanSkin) && p.Distance <= LootRange).OrderBy(l => l.Distance);
                return targetsList;
            }
        }

        private WoWGameObject[] gatherNodes
        {
            get
            {
                switch (DisSettings.AllPrefs.nodes)
                {
                    case 1 :
                        return ObjectManager.GetObjectsOfType<WoWGameObject>().Where(o => o.IsMineral).ToArray();
                    case 2: 
                        return ObjectManager.GetObjectsOfType<WoWGameObject>().Where(o => o.IsHerb || o.IsMineral).ToArray();
                    default:
                        return ObjectManager.GetObjectsOfType<WoWGameObject>().Where(o => o.IsHerb).ToArray();
                }
            }
        }

        public override void Pulse()
        {
            for (int i = 0; i < gatherNodes.Length; i++)
            {
                ShapeshiftForm shapeshift = StyxWoW.Me.Shapeshift;
                WoWGameObject node = gatherNodes[i];

                if (node.Distance <= DisSettings.AllPrefs.DismountRadius)
                {
                    if (Me.Class == WoWClass.Druid && (shapeshift == ShapeshiftForm.FlightForm || shapeshift == ShapeshiftForm.EpicFlightForm))
                    {
                        Logging.Write("Cancel Birdman mode!");
                        Lua.DoString("RunMacroText('/cancelform')");
                    }

                    if (Me.Class != WoWClass.Druid && Me.Mounted)
                    {
                        Logging.Write("Mount?");
                        Logging.Write("We don need no stinking mount!");
                        Lua.DoString("Dismount()");
                    }
                }
            }

            if (DisSettings.AllPrefs.loot)
            {
                if (Me.IsCasting || Lootables.Count() == 0 || Me.IsMoving)
                    return;
                if (LootFrame.Instance != null && LootFrame.Instance.IsVisible)
                {
                    LootFrame.Instance.LootAll();
                    return;
                }
                var lootTarget = Lootables.FirstOrDefault();
                if (lootTarget.Distance > lootTarget.InteractRange)
                {
                    slog("Moving to loot {0}.", lootTarget.Name);
                    Navigator.MoveTo(lootTarget.Location);
                }
                else
                {
                    lootTarget.Interact();
                    return;
                }
            }

        }
    }
}
